// Compiled by ClojureScript 1.9.562 {}
goog.provide('weathergen.ipc');
goog.require('cljs.core');
goog.require('weathergen.encoding');
weathergen.ipc.electron = require("electron");
weathergen.ipc.channel = "weathergen-ipc";
if(typeof weathergen.ipc.on_message !== 'undefined'){
} else {
weathergen.ipc.on_message = (function (){var method_table__24369__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var prefer_table__24370__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var method_cache__24371__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var cached_hierarchy__24372__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var hierarchy__24373__auto__ = cljs.core.get.call(null,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"hierarchy","hierarchy",-1053470341),cljs.core.get_global_hierarchy.call(null));
return (new cljs.core.MultiFn(cljs.core.symbol.call(null,"weathergen.ipc","on-message"),((function (method_table__24369__auto__,prefer_table__24370__auto__,method_cache__24371__auto__,cached_hierarchy__24372__auto__,hierarchy__24373__auto__){
return (function() { 
var G__43756__delegate = function (type,event,args){
return type;
};
var G__43756 = function (type,event,var_args){
var args = null;
if (arguments.length > 2) {
var G__43757__i = 0, G__43757__a = new Array(arguments.length -  2);
while (G__43757__i < G__43757__a.length) {G__43757__a[G__43757__i] = arguments[G__43757__i + 2]; ++G__43757__i;}
  args = new cljs.core.IndexedSeq(G__43757__a,0,null);
} 
return G__43756__delegate.call(this,type,event,args);};
G__43756.cljs$lang$maxFixedArity = 2;
G__43756.cljs$lang$applyTo = (function (arglist__43758){
var type = cljs.core.first(arglist__43758);
arglist__43758 = cljs.core.next(arglist__43758);
var event = cljs.core.first(arglist__43758);
var args = cljs.core.rest(arglist__43758);
return G__43756__delegate(type,event,args);
});
G__43756.cljs$core$IFn$_invoke$arity$variadic = G__43756__delegate;
return G__43756;
})()
;})(method_table__24369__auto__,prefer_table__24370__auto__,method_cache__24371__auto__,cached_hierarchy__24372__auto__,hierarchy__24373__auto__))
,new cljs.core.Keyword(null,"default","default",-1987822328),hierarchy__24373__auto__,method_table__24369__auto__,prefer_table__24370__auto__,method_cache__24371__auto__,cached_hierarchy__24372__auto__));
})();
}
/**
 * Sends a message from a renderer process to the main process.
 */
weathergen.ipc.send_to_main = (function weathergen$ipc$send_to_main(var_args){
var args__24566__auto__ = [];
var len__24559__auto___43762 = arguments.length;
var i__24560__auto___43763 = (0);
while(true){
if((i__24560__auto___43763 < len__24559__auto___43762)){
args__24566__auto__.push((arguments[i__24560__auto___43763]));

var G__43764 = (i__24560__auto___43763 + (1));
i__24560__auto___43763 = G__43764;
continue;
} else {
}
break;
}

var argseq__24567__auto__ = ((((1) < args__24566__auto__.length))?(new cljs.core.IndexedSeq(args__24566__auto__.slice((1)),(0),null)):null);
return weathergen.ipc.send_to_main.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__24567__auto__);
});

weathergen.ipc.send_to_main.cljs$core$IFn$_invoke$arity$variadic = (function (type,args){
return cljs.core.apply.call(null,(function (){var G__43761 = weathergen.ipc.electron.ipcRenderer;
return G__43761;
})().send,weathergen.ipc.channel,type,cljs.core.map.call(null,weathergen.encoding.encode,args));
});

weathergen.ipc.send_to_main.cljs$lang$maxFixedArity = (1);

weathergen.ipc.send_to_main.cljs$lang$applyTo = (function (seq43759){
var G__43760 = cljs.core.first.call(null,seq43759);
var seq43759__$1 = cljs.core.next.call(null,seq43759);
return weathergen.ipc.send_to_main.cljs$core$IFn$_invoke$arity$variadic(G__43760,seq43759__$1);
});

/**
 * Sends a message from the main process to a renderer process.
 */
weathergen.ipc.send_to_renderer = (function weathergen$ipc$send_to_renderer(var_args){
var args__24566__auto__ = [];
var len__24559__auto___43768 = arguments.length;
var i__24560__auto___43769 = (0);
while(true){
if((i__24560__auto___43769 < len__24559__auto___43768)){
args__24566__auto__.push((arguments[i__24560__auto___43769]));

var G__43770 = (i__24560__auto___43769 + (1));
i__24560__auto___43769 = G__43770;
continue;
} else {
}
break;
}

var argseq__24567__auto__ = ((((2) < args__24566__auto__.length))?(new cljs.core.IndexedSeq(args__24566__auto__.slice((2)),(0),null)):null);
return weathergen.ipc.send_to_renderer.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__24567__auto__);
});

weathergen.ipc.send_to_renderer.cljs$core$IFn$_invoke$arity$variadic = (function (window,type,args){
var wc = window.webContents;
var send = wc.send;
return send.apply(wc,cljs.core.clj__GT_js.call(null,cljs.core.into.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [weathergen.ipc.channel,type], null),cljs.core.map.call(null,weathergen.encoding.encode,args))));
});

weathergen.ipc.send_to_renderer.cljs$lang$maxFixedArity = (2);

weathergen.ipc.send_to_renderer.cljs$lang$applyTo = (function (seq43765){
var G__43766 = cljs.core.first.call(null,seq43765);
var seq43765__$1 = cljs.core.next.call(null,seq43765);
var G__43767 = cljs.core.first.call(null,seq43765__$1);
var seq43765__$2 = cljs.core.next.call(null,seq43765__$1);
return weathergen.ipc.send_to_renderer.cljs$core$IFn$_invoke$arity$variadic(G__43766,G__43767,seq43765__$2);
});

weathergen.ipc.ipc = ((cljs.core._EQ_.call(null,"renderer",process.type))?weathergen.ipc.electron.ipcRenderer:weathergen.ipc.electron.ipcMain);
weathergen.ipc.ipc.on(weathergen.ipc.channel,(function() { 
var G__43775__delegate = function (event,p__43771){
var vec__43772 = p__43771;
var seq__43773 = cljs.core.seq.call(null,vec__43772);
var first__43774 = cljs.core.first.call(null,seq__43773);
var seq__43773__$1 = cljs.core.next.call(null,seq__43773);
var type = first__43774;
var args = seq__43773__$1;
return cljs.core.apply.call(null,weathergen.ipc.on_message,type,event,cljs.core.map.call(null,weathergen.encoding.decode,args));
};
var G__43775 = function (event,var_args){
var p__43771 = null;
if (arguments.length > 1) {
var G__43776__i = 0, G__43776__a = new Array(arguments.length -  1);
while (G__43776__i < G__43776__a.length) {G__43776__a[G__43776__i] = arguments[G__43776__i + 1]; ++G__43776__i;}
  p__43771 = new cljs.core.IndexedSeq(G__43776__a,0,null);
} 
return G__43775__delegate.call(this,event,p__43771);};
G__43775.cljs$lang$maxFixedArity = 1;
G__43775.cljs$lang$applyTo = (function (arglist__43777){
var event = cljs.core.first(arglist__43777);
var p__43771 = cljs.core.rest(arglist__43777);
return G__43775__delegate(event,p__43771);
});
G__43775.cljs$core$IFn$_invoke$arity$variadic = G__43775__delegate;
return G__43775;
})()
);
